'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WebSocket = require('ws');

exports.default = function (port) {
  var wss = new WebSocket.Server({ port: port });

  var wsProjectMap = new _map2.default();

  var projectWsMap = (0, _create2.default)(null);

  wss.on('connection', function (ws) {
    console.info('Refresh: 新的客户端');

    ws.on('message', function (sparams) {
      var params = JSON.parse(sparams);

      if (params.isNew && params.data) {
        var pname = params.data;
        wsProjectMap.set(ws, pname);
        projectWsMap[pname] = [].concat((0, _toConsumableArray3.default)(projectWsMap[pname] || []), [ws]);
        console.info('Refresh: 新的监听项目', pname);
      }
    });

    ws.on('close', function () {
      var pname = wsProjectMap.get(ws);
      if (pname) {
        wsProjectMap.delete(ws);
        projectWsMap[pname].splice(projectWsMap[pname].indexOf(ws), 1);
        console.info('Refresh: 关闭的监听项目', pname);
      }
    });
  });

  wss.on('error', function (err) {
    console.error('Refresh: 启动 WebSocket 服务端失败');
    console.error('Refresh: errno: ' + err.errno + '; code: ' + err.code + '; port: ' + err.port);
  });

  return function (pname) {
    if (!projectWsMap[pname]) {
      return console.log('Refresh: \u901A\u77E5\u9875\u9762\u5237\u65B0\u5931\u8D25\uFF0C\u6CA1\u627E\u5230\uFF1A' + pname);
    }

    projectWsMap[pname].forEach(function (ws) {
      ws.send((0, _stringify2.default)({ isRefresh: true }));
      console.log('Refresh: \u901A\u77E5 ' + pname + ' \u9875\u9762\u5237\u65B0');
    });
  };
};